uniform float time;

void main()
{
    float  s = 1.0 + 0.5 * sin(time);
    gl_Position =  s * gl_ModelViewProjectionMatrix * gl_Vertex;

    vec4 eyePosition = gl_ModelViewMatrix * gl_Vertex;
    vec4 eyeLightPos = gl_ModelViewMatrix * gl_LightSource[0].position;

    vec3 eyeNormalVec = normalize(gl_NormalMatrix * gl_Normal);
    vec3 eyeLightVec = normalize(eyeLightPos.xyz - eyePosition.xyz);
    vec3 eyeViewVec = -normalize(eyePosition.xyz);
    vec3 eyeHalfVec = normalize(eyeLightVec + eyeViewVec);

    float Kd = dot(eyeLightVec, eyeNormalVec);
    // float Ks = pow(dot(eyeNormalVec, gl_LightSource[0].halfVector), gl_FrontMaterial.shininess);
    float Ks = pow(dot(eyeNormalVec, eyeHalfVec), gl_FrontMaterial.shininess);
    float Ka = 1.0;

    gl_FrontColor.rgb = Kd * gl_FrontLightProduct[0].diffuse +
    			Ks * gl_FrontLightProduct[0].specular +
			Ka * gl_FrontLightProduct[0].ambient +
			gl_FrontLightModelProduct.sceneColor;
     gl_FrontColor.a = 1.0;
}
